#!/usr/bin/wish -f
#DISCLAMER OF ALL WARRANTIES

#Call package --
package require	KitXml

###
# Specs
#
set _htmltcl(htmlspecs) {
	{"a"		""	""	""	}
	{-alt		""	""	"" 	}
	{-href		""	""	""	}
	{-nosave	""	""	""	}
	{-target	""	""	"_top"  }

	{"body"		""	""	""	}
	{-alink		""	""	#FF0000 }
	{-background	""	""	""	}
	{-bgcolor	""	""	#FFFFFF }
	{-image		""	""	""	}
	{-link		""	""	#0000FF }
	{-onload	""	""	""	}
	{-text		""	""	#000000	}
	{-vlink		""	""	#FF00FF }

	{"div"		""	""	""	}
	{-style		""	""	""	}
	{-id		""	""	""	}
	
	{"font"		""	""	""	}
	{-color		""	""	""	}
	{-size		""	""	""	}

	{"frame"	""	""	""	}
	{-name		""	""	""	}
	{-noresize	""	""	""	}
	{-src		""	""	""	}

	{"frameset"	""	""	""	}
	{-border	""	""	0	}
	{-cols		""	""	"*"	}
	{-frameborder	""	""	0	}
	{-framespacing	""	""	0	}
	{-rows		""	""	"*"	}

	{"h1,h2,h3,h4,h5,h6"	""	""	""	}
	{-align		""	""	"right"	}

	{"hr"		""	""	""	}
	{-width		""	""	"100%"	}

	{"table"	""	""	""	}
	{-cellspacing	""	""	""	}
	{-cellpadding	""	""	""	}
	{-height	""	""	"100%" 	}
	{-width		""	""	"100%"	}
	
	{"html"		""	""	""	}
	{-content	""	""	""	}
	{-http-equiv	""	""	""	}

	{"script"	""	""	""	}
	{-language	""	""	""	}
		
}

###
# HtmlTcl_HtmlShow
#
proc HtmlTcl_HtmlShow { w node ptag } {
	
	HtmlTcl_ParseTag $w $node $ptag
	set childnodeslist [$node get nodeslist]
	if { $childnodeslist!=""} {
		foreach child "$childnodeslist" {
			HtmlTcl_HtmlShow  $w $child "$ptag [$child info tagname]"
		}
	}

}

###
# HtmlTcl_FormatHtmlArsList
#
proc HtmlTcl_FormatHtmlArgsList { tag } {

	set result ""
	set proplist [$tag get propertieslist]
	foreach sel "$proplist" {
		set value [$tag get property $sel]
		set result "$result $sel \"$value\""	
	}
	return $result

}

###
# HtmlTcl_GetPrivateVar
#
proc HtmlTcl_GetPrivateVar { name } {

	global _htmltcl
	return [set _htmltcl($name)]

}

###
# HtmlTcl_Node2Text
#
proc HtmlTcl_ParseTag { w tag parenttags } {

	global _htmltcl $w

	set tagname  [$tag info tagname]
	set childlist [$tag get nodeslist]
	set args  [HtmlTcl_FormatHtmlArgsList $tag]
	set result "{}"
	upvar #0 . data 
	tclParseConfigSpec . $_htmltcl(htmlspecs) "" $args	

	switch $tagname {
		a	{
			$w.body tag bind $tag <1>  "HtmlTcl_SetPrivateVar selection $tag" 
			$w.body tag bind $tag <Button-2>  "HtmlTcl_SetPrivateVar selection $tag" 
			$w.body tag bind $tag <Button-3>  "HtmlTcl_SetPrivateVar selection $tag" 
			$w.body tag bind $tag <Any-Leave>  "HtmlTcl_SetPrivateVar selection {}"
			set _htmltcl(selection) $tag
		}
		body	{ 
			if { [set [set w](frameset)] ==0} {

				#text
				text $w.body -relief flat -bd 0 -yscrollcommand "$w.body.scrolly set" -xscrollcommand "$w.scrollx set" \
					-setgrid 1 -wrap none -cursor top_left_arrow -foreground $data(-text) -background $data(-bgcolor)\
					-width 20 -height 30 -font { helvetica 14 }
				scrollbar $w.scrollx -command "$w.body xview" -orient horiz -width 10 -background #C7C7C7
				scrollbar $w.body.scrolly -command "$w.body yview"  -width 10 -background #C7C7C7
				pack $w.body -expand yes -fill both 
				pack $w.body.scrolly  -fill y -side right 
				pack $w.scrollx  -fill x 
	
				#configure tags 
				$w.body tag configure 	center -justify center
				$w.body tag configure 	h1	-font { helvetica 18 bold } 
				$w.body tag configure 	a  	-underline 1 -foreground $data(-link)
				$w.body tag configure 	b  	-font [linsert [$w.body cget -font] end bold]
				$w.body tag configure   blockquote -lmargin1 20
				#$w.body tag configure 	a  	-italic 1

				#bindings
				bind $w.body <1> "event generate $w <1>"
				bind $w.body <Button-2> "event generate $w <Button-2>"
				bind $w.body <Button-3> "event generate $w <Button-3>"
			}
		}
		blokquote {  
		}
		br	{
			$w.body insert end  "\n"
		}
		font	{
			$w.body tag configure $tag -foreground $data(-color)
			set _htmltcl(selection) $tag
		}
		frame   {
			#new frame
			frame $w.$data(-name) -width 200 -height 200; pack $w.$data(-name) -expand yes -fill both -side left
			
			#bindings
			bind $w.$data(-name) <1> "event generate $w <1>"
			bind $w.$data(-name) <Button-2> "event generate $w <Button-2>"
			bind $w.$data(-name) <Button-3> "event generate $w <Button-3>"			
			
			#open html file
			xml $w.$data(-name).file -html -file $data(-src)
			HtmlTcl_HtmlShow $w.$data(-name) $w.$data(-name).file.html ""
		}
		frameset { 
			set [set w](frameset) 1
		}
		html	{ 
			set [set w](frameset) 0
			set [set w](title) "HtmlTcl Browser"
		}
		p	{
			$w.body insert end "\n"
		}
		text	{
			if {[HtmlTcl_TestList $parenttags { html head title }]==0} {
				if {[HtmlTcl_TestList $parenttags { a font } ]==0} {
					set result "{[$tag get content]} {$parenttags}" 
				} {
					set result "{[$tag get content]} {$parenttags $_htmltcl(selection)}" 
				}
				if {[lsearch $parenttags blockquote]>=0} { $w.body insert end  "\n" }
				eval "$w.body insert end  $result"
				if {[lsearch $parenttags blockquote]>=0} { $w.body insert end  "\n" }
			}
		}
		title 	{
			set [set w](title) [$tag get content]
		}
	}
	
	return result
}

###
# HtmlTcl_SetPrivateVar
#
proc HtmlTcl_SetPrivateVar { name value } {

	global _htmltcl
	set _htmltcl($name) $value

}

###
# HtmlTcl_TestList
#
proc HtmlTcl_TestList { lsrc lsearch } {
	foreach sel "$lsearch" {
		if {[lsearch $lsrc $sel]!=-1} { return 1 }
 	}
	return 0
}

###
# HtmlTcl_Info
#
proc HtmlTcl_Info { w name } {
	global $w
	eval "set result [set w]($name)"
	return [set $result]
}


#############################
#
# MAIN --
#

set _htmltcl(selection) ""

set file [tk_getOpenFile -filetypes { { html *.html WebFile} { All * All } } -initialfile "*.html"]
if [file exist $file]==0 then { tk_messageBox -message "Open <<$file>>, failed. it is not exist!" ; exit } 

set w ._top 
frame $w ; pack $w -expand yes -fill both
xml $w.file -html -file $file
HtmlTcl_HtmlShow $w $w.file.html  ""

wm title . [HtmlTcl_Info  $w title]

bind $w <1> {tk_messageBox -message [HtmlTcl_GetPrivateVar  selection]}
bind $w <Button-2> {tk_messageBox -message [HtmlTcl_Info  $w title]}
bind $w <Button-3> {tk_messageBox -message [HtmlTcl_GetPrivateVar  selection]}


wm geometry . 50x50+0+0

#
# END --
#
###############################










