#!/bin/sh
# the next line restarts using tclsh \
exec wish "$0" "$@"
#DISCLAMER OF ALL WARRANTIES

#package require	KitXml
load libkitxml0.1.4.dylib

wm title . "Create Xml File Demos"
wm geometry . +0+0

# create a new file and widget xml 
xml .xml1 

# create 1st children node, "book" 
.xml1 root node .book

# add "book" another properties 
.xml1.book add properties -author "Cyril BARBATO" -date "Febuary 23, 2002" -number_of_page "0"

# change a number_of_page property
.xml1.book set property -number_of_page "1"

# add "title" node
.xml1.book add node .title -content "The KitXml Programmer's Manual" 	

# add "chapter1" node
 .xml1.book add node .chapter1 -content "1) Introduce" 

# add "chapter2" node 
.xml1.book add node .chapter2 -content "2) Installation" 

# read and show xml data 
label	.file_name 	-text "File : [.xml1 cget -file]"
pack  	.file_name
label	.root_name	-text "Root node name : [.xml1 get root ]"
pack	.root_name
label   .book_nodeslist -text "Root node childrens list : [.xml1.book get nodeslist]"
pack 	.book_nodeslist
label   .book_propertieslist -text "Root node properties list : [.xml1.book get propertieslist]"
pack 	.book_propertieslist
label 	.book_property 	-text "Author : [.xml1.book get property -author] \n \
Date : [.xml1.book get property -date]	\n \
NPage : [.xml1.book get property -number_of_page]"
pack 	.book_property
label 	.book_title 	-text [.xml1.book.title get content]
pack 	.book_title
label 	.book_chapter1 	-text [.xml1.book.chapter1 get content]
pack 	.book_chapter1
label 	.book_chapter2 	-text [.xml1.book.chapter2 get content]
pack 	.book_chapter2

# save xml tree in default file 
.xml1 save

# show file result 
set id [open [file join [.xml1 cget -file]]]
text .file_content 	
.file_content insert end [read $id] 
pack .file_content -expand yes -fill both
close $id  


button .quit -text Quit -command { destroy . ; exit }
pack .quit




