/* 
 * XmlTclInit.c (c) 2010 Cyril BARABTO 
 *
 *	This file contains code to implement the "packer"
 *	XML file manager for Tcl/Tk.
 *
 * libxml (c) 1999-2010 Daniel Veillard
 * tcl/tk (c) 1990-2010 The Regents of the University of California.
 * 	  (c) 1994-2010 Sun Microsystems, Inc.
 *
 * DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include "XmlTclInit.h"

/*
 *--------------------------------------------------------------
 *
 * Kitxml_Init --
 *
 *	This procedure is invoked to process the "load libxmltcl xmltcl" Tcl command
 *	and creates the new tcl command about XML file manager.
 *	See the user documentation for details on what it does.
 *
 * Results:
 *	A standard Tcl result.
 *
 * Side effects:
 *	See the user documentation.
 *
 *--------------------------------------------------------------
 */


int 
Kitxml_Init(Tcl_Interp *interp) {
	
	
	Tcl_Command code = NULL; /*set code error*/
	
	// For futur devel *****************
	//Tk_Window tkwin = Tk_MainWindow(interp); /* set tkwin main */
	char *tkwin = NULL;

	/*create news tcl commands  */
	/*xml*/
	Tcl_CreateCommand(interp, "xml", XmlTcl_XmlCmd, (ClientData)
		tkwin, (void (*) _ANSI_ARGS_((ClientData))) NULL); 
	
	/* declare package */
	Tcl_PkgProvide(interp, XMLTCL_PKG, XMLTCL_VERSIONID);
	
	/*load message */
	printf("%s %s.%s.%s package for Tcl/Tk by Cyril BARBATO (c) %s\n", XMLTCL_PKG, XMLTCL_VERSION, XMLTCL_REVISION, XMLTCL_DEBUG, XMLTCL_DATE);	

	return TCL_OK;

};

/*
 *--------------------------------------------------------------
 *
 * XmlTcl_GetEqu --
 *
 * return int (index) equ string (char *) from XaTcl_Equ table.
 * return 0 if not exist
 *
 *--------------------------------------------------------------
 */

int 
XmlTcl_GetEqu (char *name, XmlTcl_Equ *equTable) {

	int i = 0;
	int result = 0;
	
	for ( i = 0 ; (result == 0) && (equTable[i].name != 0) ; i++ ) {
		if (strncmp(name, equTable[i].name, strlen(name)) == 0 ) result = equTable[i].index ;
	};

	return result;
};
